/**
 * RPI vcgencmd
 */
const child = require('child_process');

const plugin = require('ih-plugin-api')();

plugin.params
  .get()
  .then(params => {
    let interval = params.interval > 0 ? params.interval : 5;
    setInterval(pollAndSend, interval * 1000);
  })
  .catch(e => {
    plugin.exit(1, 'ERROR! ' + JSON.stringify(e));
  });

function pollAndSend() {
  // plugin.log('pollAndSend');
  child.exec('vcgencmd measure_temp', (error, stdout, stderr) => {
    let err = 1;
    let value;
    if (error) {
      plugin.log(`exec error: ${error}`);
    } else if (stderr) {
      plugin.log(`stderr: ${stderr}`);
    } else if (stdout) {
      plugin.log(`stdout: ${stdout}`);

      if (stdout && stdout.substr(0, 4) == 'temp') value = parseFloat(stdout.split('=').pop());
      err = value == undefined ? 1 : 0;
    } else {
      plugin.log(`EMPTY stdout!!`);
    }
    plugin.sendData({ id: 'CPU_TEMP', value, err });
  });
}
